// Code generated by mockery v2.20.0. DO NOT EDIT.

package mockclients

import (
	context "context"

	mock "github.com/stretchr/testify/mock"

	types "gitlab.com/infor-cloud/martian-cloud/tharsis/tharsis-sdk-go/pkg/types"
)

// Variable is an autogenerated mock type for the Variable type
type Variable struct {
	mock.Mock
}

// CreateVariable provides a mock function with given fields: ctx, input
func (_m *Variable) CreateVariable(ctx context.Context, input *types.CreateNamespaceVariableInput) (*types.NamespaceVariable, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.NamespaceVariable
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateNamespaceVariableInput) (*types.NamespaceVariable, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateNamespaceVariableInput) *types.NamespaceVariable); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.NamespaceVariable)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.CreateNamespaceVariableInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteVariable provides a mock function with given fields: ctx, input
func (_m *Variable) DeleteVariable(ctx context.Context, input *types.DeleteNamespaceVariableInput) error {
	ret := _m.Called(ctx, input)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.DeleteNamespaceVariableInput) error); ok {
		r0 = rf(ctx, input)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetVariable provides a mock function with given fields: ctx, input
func (_m *Variable) GetVariable(ctx context.Context, input *types.GetNamespaceVariableInput) (*types.NamespaceVariable, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.NamespaceVariable
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetNamespaceVariableInput) (*types.NamespaceVariable, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetNamespaceVariableInput) *types.NamespaceVariable); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.NamespaceVariable)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetNamespaceVariableInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// SetVariables provides a mock function with given fields: ctx, input
func (_m *Variable) SetVariables(ctx context.Context, input *types.SetNamespaceVariablesInput) error {
	ret := _m.Called(ctx, input)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.SetNamespaceVariablesInput) error); ok {
		r0 = rf(ctx, input)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// UpdateVariable provides a mock function with given fields: ctx, input
func (_m *Variable) UpdateVariable(ctx context.Context, input *types.UpdateNamespaceVariableInput) (*types.NamespaceVariable, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.NamespaceVariable
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdateNamespaceVariableInput) (*types.NamespaceVariable, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdateNamespaceVariableInput) *types.NamespaceVariable); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.NamespaceVariable)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.UpdateNamespaceVariableInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

type mockConstructorTestingTNewVariable interface {
	mock.TestingT
	Cleanup(func())
}

// NewVariable creates a new instance of Variable. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewVariable(t mockConstructorTestingTNewVariable) *Variable {
	mock := &Variable{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
